function [AU, h_it, U_it] = Verfahren1(U0, h, tol, f)
% modified Version of exercise 2.6 for highdimensional problems

if size(U0,1) < size(U0,2) % ensure column vector input
    U0 = U0';
end
N =  length(U0); % number of nodes
n = sqrt(N); % number of nodes ine ach direction
if floor(n) ~= n
    error('Anzahl Knoten ist nicht quadratisch!')
end
% get all the indices of the inner nodes - only the directions there are to
% be considered since the boundary has to remain constant!
l = (n-2)^2; %number of inner nodes
Inner_Ind = zeros(l,1);
for i = 1:n-2
    for j = 1:n-2
        Inner_Ind((i-1)*(n-2) + j) = i*n + j+1;
    end
end;
% construct the positive and negative directions in each inner point
dir = sparse(repmat(Inner_Ind,2,1),1:2*l,[ones(1,l), -ones(1,l)],N,2*l);

% compute first value at current point and save some output - ensure column vectors for convenience
i = 1;
z_current = U0;
AU(i,1) = f(z_current);
h_it(i,1) = h;
U_it(:,i) = z_current;

while h > tol % as long as tolerance isn't reached

    % compute function value in each direction
    f_val = zeros(2*l,1);
    for q = 1:l
        f_val(q) = f(U_it(:,i)+h*dir(:,q));
        f_val(l+q) = f(U_it(:,i)+h*dir(:,l+q));
    end
    
    % compute min and argmin of function values at current point and values
    % in all directions
    [f_val_min, ind] = min([f_val;AU(i,1)]);
    % If minimal function value doesn't differ from the current halve the step size
    if abs(AU(i,1) - f_val_min) < 1e-12
        h = h/2;
    else % else move in the respective direction
        z_current = z_current + h*dir(:,ind);
    end
    i = i+1;
    % save function value at new point and some output
    AU(i,1) = f_val_min;
    h_it(i,1) = h;
    U_it = [U_it, z_current];
    disp([h, i])  % optionaler output: damit man abschätzen kann, wie lange das Verfahren noch braucht
end